/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */

package org.dive4elements.river.artifacts.model.minfo;

import gnu.trove.TDoubleArrayList;


public class BedHeightSingleData
extends BedHeightData
{
    protected Integer year;
    protected TDoubleArrayList data_gap;
    protected TDoubleArrayList soundingWidth;

    public BedHeightSingleData() {
        super();
        data_gap = new TDoubleArrayList();
        soundingWidth = new TDoubleArrayList();
    }

    public BedHeightSingleData(String name) {
        super(name);
        data_gap = new TDoubleArrayList();
        soundingWidth = new TDoubleArrayList();
    }

    public void add(
        double value,
        double station,
        double gap,
        double sounding,
        Integer year
    ) {
        super.add(value, station);
        if (year != null) {
            this.year = year;
        }
        this.data_gap.add(gap);
        this.soundingWidth.add(sounding);
    }

    public Integer getYear() {
        return this.year;
    }

    public double getSoundingWidth(int idx) {
        return this.soundingWidth.getQuick(idx);
    }

    public double getDataGap(int idx) {
        return this.data_gap.getQuick(idx);
    }

    public double getSoundingWidth(double station) {
        int index = this.station.indexOf(station);
        return index >= 0 ? soundingWidth.getQuick(index): Double.NaN;
    }

    public double getDataGap(double station) {
        int index = this.station.indexOf(station);
        return index >= 0 ? data_gap.getQuick(index) : Double.NaN;
    }

    public double[] getSoundingWidths() {
        return this.soundingWidth.toNativeArray();
    }

}
